3 # Copyright (c) 2005 Junio C Hamano
6 # For repeatability, reset the environment to known value.
11 export LANG LC_ALL PAGER TZ
17 unset COMMIT_AUTHOR_EMAIL
18 unset COMMIT_AUTHOR_NAME
19 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
21 GIT_AUTHOR_EMAIL=author@example.com
22 GIT_AUTHOR_NAME='A U Thor'
23 unset GIT_COMMITTER_DATE
24 GIT_COMMITTER_EMAIL=committer@example.com
25 GIT_COMMITTER_NAME='C O Mitter'
28 unset GIT_EXTERNAL_DIFF
30 unset GIT_OBJECT_DIRECTORY
31 unset SHA1_FILE_DIRECTORIES
32 unset SHA1_FILE_DIRECTORY
34 export GIT_MERGE_VERBOSITY
35 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
36 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
39 # Protect ourselves from common misconfiguration to export
40 # CDPATH into the environment
43 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
45 echo "* warning: Some tests will not work if GIT_TRACE" \
46 "is set as to trace on STDERR ! *"
47 echo "* warning: Please set GIT_TRACE to something" \
48 "other than 1, 2 or true ! *"
52 # Each test should start with something like this, after copyright notices:
54 # test_description='Description of this test...
55 # This test checks if command xyzzy does the right thing...
69 test "${test_description}" != "" ||
70 error "Test script did not set test_description."
75 -d|--d|--de|--deb|--debu|--debug)
77 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
79 -h|--h|--he|--hel|--help)
80 echo "$test_description"
82 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
93 if test "$verbose" = "t"
97 exec 4>/dev/null 3>/dev/null
103 trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
106 if test -z "${test_tick+set}"
110 test_tick=$(($test_tick + 60))
112 GIT_COMMITTER_DATE="$test_tick -0700"
113 GIT_AUTHOR_DATE="$test_tick -0700"
114 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
117 # You are not expected to call test_ok_ and test_failure_ directly, use
118 # the text_expect_* functions instead.
121 test_count=$(expr "$test_count" + 1)
122 say " ok $test_count: $@"
126 test_count=$(expr "$test_count" + 1)
127 test_failure=$(expr "$test_failure" + 1);
128 say "FAIL $test_count: $1"
130 echo "$@" | sed -e 's/^/ /'
131 test "$immediate" = "" || { trap - exit; exit 1; }
136 test "$debug" = "" || eval "$1"
146 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
147 this_test="$this_test.$(expr "$test_count" + 1)"
149 for skp in $GIT_SKIP_TESTS
158 say >&3 "skipping test: $@"
159 test_count=$(expr "$test_count" + 1)
160 say "skip $test_count: $1"
169 test_expect_failure () {
171 error "bug in the test script: not 2 parameters to test-expect-failure"
174 say >&3 "expecting failure: $2"
176 if [ "$?" = 0 -a "$eval_ret" != 0 -a "$eval_ret" -lt 129 ]
186 test_expect_success () {
188 error "bug in the test script: not 2 parameters to test-expect-success"
191 say >&3 "expecting success: $2"
193 if [ "$?" = 0 -a "$eval_ret" = 0 ]
203 test_expect_code () {
205 error "bug in the test script: not 3 parameters to test-expect-code"
208 say >&3 "expecting exit code $1: $3"
210 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
220 # Most tests can use the created repository, but some amy need to create more.
221 # Usage: test_create_repo <directory>
222 test_create_repo () {
224 error "bug in the test script: not 1 parameter to test-create-repo"
228 cd "$repo" || error "Cannot setup test environment"
229 "$GIT_EXEC_PATH/git" init --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
230 error "cannot run git init -- have you built things yet?"
231 mv .git/hooks .git/hooks-disabled
237 case "$test_failure" in
240 # cd .. && rm -fr trash
241 # but that means we forbid any tests that use their own
242 # subdirectory from calling test_done without coming back
243 # to where they started from.
244 # The Makefile provided will clean this test area so
245 # we will leave things as they are.
247 say "passed all $test_count test(s)"
251 say "failed $test_failure among $test_count test(s)"
257 # Test the binaries we have just built. The tests are kept in
258 # t/ subdirectory and are run in trash subdirectory.
260 GIT_EXEC_PATH=$(pwd)/..
261 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
262 GIT_CONFIG=.git/config
263 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG
265 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
267 test -d ../templates/blt || {
268 error "You haven't built things yet, have you?"
271 if ! test -x ../test-chmtime; then
272 echo >&2 'You need to build test-chmtime:'
273 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
280 test_create_repo $test
283 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
284 for skp in $GIT_SKIP_TESTS
287 for skp in $GIT_SKIP_TESTS
296 say >&3 "skipping test $this_test altogether"
297 say "skip all tests in $this_test"